<template>
  <crud-data-table-update
    :item="value"
    @onSave="onSave(value)"
    @emitTheValueBeforeEditOnClose="emitValueToParent"
  >
    <v-btn icon>
      <paint-bucket-icon :color="value" />
    </v-btn>
    <template v-slot:dialog>
      <v-form
        ref="form"
        @submit.prevent
      >
        <color-picker-field
          v-bind="$attrs"
          single-line
          :value="value"
          v-on="$listeners"
          @input="emitValueToParent"
        />
      </v-form>
    </template>
  </crud-data-table-update>
</template>

<script>
  import commonMessages from '../../commonMessages'

  export default {
    name: 'EditColorDialog',
    inheritAttrs: false,
    props: {
      value: String,
      itemId: {
        type: Number,
        required: true,
      },
    },
    methods: {
      onSave (color) {
        if (this.$refs.form.validate()) {
          this.$store.dispatch('paymentMethods/updatePaymentMethodColor', {
            ID: this.itemId,
            color,
          })
            .then(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('updateSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('updateError'),
              })
            })
        }
      },
      emitValueToParent (event) {
        this.$emit('input', event)
      },
    },
    i18n: {
      sharedMessages: commonMessages,
    },
  }
</script>
